<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 150 post lists </title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container text-center">
    <div class="text-center my-4">
      <h3 class="text-info">Danh sách bài đăng của người dùng (POSTS OF USERS)</h3>
    </div>
    <div class="row form-group">
      <div class="col-sm-2">
        <label class="form-control border border-0 text-dark"> Điền Post id: </label>
      </div>
      <div class="col-sm-6">
        <input type="text" class="form-control" id="inp-user-id" placeholder="Gợi ý Post id đúng: 3, 4, 5...">
      </div>
      <div class="col-sm-4">
        <button class="btn btn-info form-control" id="btn-get-user-posts"> Lấy danh sách bài viết (post) </button>
      </div>
    </div>
    <table class="table table-bordered table-striped table-hover" id="tbl-user-posts">
      <thead>
        <tr>
          <th>ID</th>
          <th>Post (ID)</th>
          <th>Email</th>
          <th>Name</th>
          <th>Body</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>

  <script>
    "use strict";

    /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gEND_OF_ROW_COL = -1;
    const gBASE_URL = "https://jsonplaceholder.typicode.com";


    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $("#btn-get-user-posts").on("click", function(){
    getPostBtn();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện lấy post của người dùng (4 bước xử lý)
    function getPostBtn(){
      
      //get data from web
      var vIdInputElement = $("#inp-user-id").val();
      console.log(vIdInputElement);
      //validate the data
      if (vIdInputElement == ""){
        alert("Hãy nhập Post ID");
        return;
      };
      
      //call API for getting the comments' list
      $.ajax ({
        url: gBASE_URL + "/posts/" + vIdInputElement + "/comments/" ,
        type: "GET",
        success: function(res){
          console.log(Object.entries(res));
          loadDataToTable(res);
        },
        error: function(ajaxContext){
          console.log(ajaxContext);
        },
      });
    }
  
    //function for loading the data to table
    function loadDataToTable(paramData){
  
      var vTable = $("#tbl-user-posts");
  
      for (var bI=0; bI < paramData.length; bI++){
        //create a row of the table
        var vNewRow = $("<tr>").appendTo(vTable);
        //create cells of the rows
        $("<td>", {html: paramData[bI].id}).attr("class", "text-center").appendTo(vNewRow);
        $("<td>", {html: paramData[bI].postId}).attr("class", "text-center").appendTo(vNewRow);
        $("<td>", {html: paramData[bI].email}).appendTo(vNewRow);
        $("<td>", {html: paramData[bI].name}).appendTo(vNewRow);
        $("<td>", {html: paramData[bI].body}).appendTo(vNewRow);
  
        //create Detail Button in the action column
        var vAction = $("<td>").appendTo(vNewRow);
        var vDetailBtn = $("<button>")
        .html("Detail")
        .attr("class", "btn btn-warning btn-detail")
        .data("id", paramData[bI].id)
        .appendTo(vAction);
        //add click event for the Detail Button  
        vDetailBtn.click(onDetailBtnClick);
      }
    }
  
    //add event for Detail Button
    function onDetailBtnClick(paramData){
    
    const vPOST_DETAIL = "task.Bs150PostDetail.html"
    var vId = paramData.currentTarget;
    var vUrlSiteToOpen = vPOST_DETAIL + "?" + "id=" + $(vId).data("id");
    window.location.href = vUrlSiteToOpen;

  }

  </script>
</body>

</html>